# Localdev Registry

This [repository](https://forgejo.edf-bootstrap.cx.fg1.ffm.osc.live/DevFW/localdev-registry) provides documentation and code for the usage of docker image pulling caching mechanisms.

## Overview: Usage scenarios

This are two mechanisms: Registry mirroring and registry proxying. 
While the first redirects image pull requests to a real registry clone serving OCI requests and thus behaves as a representative, the second justs caches HTTP responses and acts as an object cache speeding up traffic.

As we need these two mechanisms in two settings 'local kind' and 'local docker', there result four scenarios which need to be implemented:

1. kind-mirror
1. kind-proxy-cache
1. docker-mirror
1. docker-proxy-cache

There is information about how to use and deploy these scenarios manually on the local box, and there is code for automating the deployment either by shell commands or in edpbuilder provissioning code.

## How to use this documentation

As of sprint 1, you can
1. read the [conceptual overview](./1-registry-mirror-and-cache-proxy-theory.md) 
1. [set up one or a combination of the usage scenarions manually on your box](./2-registry-mirror-and-cache-proxy-manual-installation.md)

Additionally there is a documentation about ['hacking' a local mirror](./3-registry-mirror-and-cache-proxy-hacks.md), if you like to test the mirroring scenarios independently of external mirror registries.